// RunsUpDown.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <time.h>
#include <math.h>

//
// Function declarations
//
long error(long *rc, long scode, char *loc_str, char *err_str);

int main()
{
FILE*			pInfile = NULL;
FILE*			pOutfile = NULL;
float			mean = 0;
float			stdDev = 0;
float			Z = 0;
long			rc = 0;
long			idx = 0;
long			numBytes = 0;
unsigned long	data = 0;
unsigned long	data1 = 0;
unsigned long	upDownFlag = 0;
unsigned long	numUpRuns = 0;
unsigned long	numDownRuns = 0;
unsigned long	numRuns = 0;
unsigned long	bytesRead = 0;
char			inFileName[36];

rc = 0;
upDownFlag = -1;						// Initialize to "no direction yet".
numBytes = 0;
numRuns = 0;
numUpRuns = 0;
numDownRuns = 0;
inFileName[0] = '\0';
printf("Name of input file: ");			// Get the input file.
scanf("%s", &inFileName);
// printf("File length in bytes: ");	// Get the length of the input file
// scanf("%d", &numBytes);				// in bytes..
// if (numBytes == 0) goto exit;

pInfile = fopen(inFileName, "r+b");
if (pInfile == NULL)
  {
  error(&rc, 'F', "RUD 300", "F - Error opening input file.");
  rc = 1;
  goto exit;
  }

pOutfile = fopen("results.txt", "w+b");
if (pOutfile == NULL)
  {
  error(&rc, 'F', "RUD 320", "F - Error opening output file.");
  rc = 1;
  goto exit;
  }

//
// Initialize the sequence of runs
//
bytesRead = fread(&data, 1, 1, pInfile);	// Get a byte.
if (bytesRead != 1)
  {
  error(&rc, 'F', "RUD 340", "F - Error reading input file.  Exiting");
  goto exit;
  }

data &= 0xFF;
numBytes = 1;

//
// Count the runs
//
while (1)
  {
  bytesRead = fread(&data1, 1, 1, pInfile);	// Get a byte.
  if (bytesRead != 1)
	break;									// We're done.

  data1 &= 0xFF;
  ++numBytes;

  if (data1 == data)						// If we're not changing direction,
	continue;								// cycle the loop.

  if (upDownFlag == -1)						// If we don't have a run direction yet
	{										// (i.e., if it's the first run),
	if (data1 < data)
	  {
	  upDownFlag = 0;						// Set "we're now in a "down" run".
	  }
	else if (data1 > data)
	  {
	  upDownFlag = 1;						// Set "we're now in an "up" run".
	  }

	data1 = data;
	continue;
	}

  if ((upDownFlag == 1) && (data1 < data))	// if we're in an "up" run and the
	{										// run has ended,
	++numUpRuns;							// count the "up" run, and
	upDownFlag = 0;							// change the flag.
	}
  else if ((upDownFlag == 0) && (data1 > data))	// if we're in a "down" run and the
	{										// run has ended,
	++numDownRuns;							// count the "down" run, and
	upDownFlag = 1;							// change the flag.
	}

  data = data1;
  continue;
  }

numRuns = numUpRuns + numDownRuns;
mean = (2*(float)numBytes - 1.0) / 3.0;
stdDev = sqrt((16.0*(float)numBytes - 29.0) / 90.0);
Z = (numRuns - mean) / stdDev;
fprintf(pOutfile, "Number of numbers (bytes) = %d\n", numBytes);
fprintf(pOutfile, "Number of runs = %d\n", numRuns);
fprintf(pOutfile, "Number of up runs = %d\n", numUpRuns);
fprintf(pOutfile, "Number of down runs = %d\n", numDownRuns);
fprintf(pOutfile, "Mean = %f\n", mean);
fprintf(pOutfile, "Standard deviation = %f\n", stdDev);
fprintf(pOutfile, "Z = %f\n", Z);

error(&rc, 'I', "RUD 380", "Done, exiting.");
rc = 0;

exit:
if (pInfile != NULL) fclose(pInfile);
if (pOutfile != NULL) fclose(pOutfile);
if (rc != 0)
  error(&rc, 'F', "RUD 500", "F - An error occurred.  Exiting.");

system("pause");
return 0;
}
